# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

Public Member Functions | Protected Attributes | Private Member Functions | List of all members
dirac::BiBlockDiff Class Referenceabstract

A virtual class for bi-directional differences.

`#include <me_utils.h>`

Inheritance diagram for dirac::BiBlockDiff:
[legend]
Collaboration diagram for dirac::BiBlockDiff:
[legend]

## Public Member Functions
| BiBlockDiff (const PicArray &ref1, const PicArray &ref2, const PicArray &pic)
| Constructor, initialising the references and picture data. More...
virtual | ~BiBlockDiff ()
| Virtual destructor. More...
virtual float | Diff (const BlockDiffParams &dparams, const MVector &mv1, const MVector &mv2)=0
| Do the difference, returning SAD. More...

## Protected Attributes
const PicArray & | m_pic_data
const PicArray & | m_ref_data1
const PicArray & | m_ref_data2

## Private Member Functions
| BiBlockDiff (const BiBlockDiff &cpy)
| Private, bodyless copy-constructor: class should not be copied. More...
BiBlockDiff & | operator= (const BiBlockDiff &rhs)
| Private, bodyless assignment=: class should not be assigned. More...

## Constructor & Destructor Documentation

## ◆ BiBlockDiff() [1/2]

dirac::BiBlockDiff::BiBlockDiff | ( | const PicArray & | ref1,
|  | const PicArray & | ref2,
|  | const PicArray & | pic
| ) |  |

## ◆ ~BiBlockDiff()

virtual dirac::BiBlockDiff::~BiBlockDiff | ( |  | ) |
| inline virtual

## ◆ BiBlockDiff() [2/2]

dirac::BiBlockDiff::BiBlockDiff | ( | const BiBlockDiff & | cpy | ) |
| private

## Member Function Documentation

## ◆ Diff()

virtual float dirac::BiBlockDiff::Diff | ( | const BlockDiffParams & | dparams,
|  | const MVector & | mv1,
|  | const MVector & | mv2
| ) |  |
| pure virtual

Do the difference, returning SAD

Parameters

  dparams | block parameters
  mv1 | the motion vector being used for reference 1
  mv2 | the motion vector being used for reference 2

Implemented in dirac::BiBlockHalfPel, dirac::BiBlockQuarterPel, and dirac::BiBlockEighthPel.

## ◆ operator=()

BiBlockDiff & dirac::BiBlockDiff::operator= | ( | const BiBlockDiff & | rhs | ) |
| private

## Member Data Documentation

## ◆ m_pic_data

const PicArray& dirac::BiBlockDiff::m_pic_data
| protected

## ◆ m_ref_data1

const PicArray& dirac::BiBlockDiff::m_ref_data1
| protected

## ◆ m_ref_data2

const PicArray& dirac::BiBlockDiff::m_ref_data2
| protected

The documentation for this class was generated from the following file:

- me_utils.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.